const Success_Status = 1
const Error_Status = 0
const serviceToController = (status, data, description) => {

  return {
    status: status,
    data: data,
    description: description ? description : "",
  }
};

const Success = (res, data, description = "", status = Success_Status) => {
  res.status(200).json({ status: status, description: description ? description : "", data: data })
}

const Error = (res, description, status = Error_Status) => {
  res.status(200).json({ status: status, description: description })
};

const InternalServerError = (res, description, status = Error_Status) => {
  res.status(500).json({ status: status, description: description })
};



// when data are invalid
const BadRequest = (resp, description) => {
  resp.status(400).json({
    status: Error_Status,
    description: description ? description : "",
    data: [],
  });
};

module.exports = {
  serviceToController,
  Success,
  Error,
  BadRequest,
  InternalServerError
}