const { Sequelize } = require("sequelize");
const {
    DATABASE,
    DATABASEUSERNAME,
    DATABASEPASSWORD,
    DATABASEHOST }= require("./config");

const { logger } = require("./utils/logger");

const sequelize = new Sequelize
    (
        DATABASE,
        DATABASEUSERNAME,
        DATABASEPASSWORD,
        {
            host:DATABASEHOST,
            dialect:"mysql",
            logging:false,
            pool:{
                max:5,
                min:0,
                acquire:30000,
                idle:10000,
            }
        }
    );

sequelize.authenticate()
.then(()=>{
    logger.info("Connection has been established successfully...")
}).catch((error)=>{
    logger.error("Unable to Connect to the Database :", error );
});

module.exports = sequelize;