const express = require("express");
const app = express();
const { PORT } = require("./config");
const database = require("./database");
const bodyParser = require("body-parser");
const { logger } = require("./utils/logger");
const cors = require("cors");
const https = require("https");
const fs = require("fs");
app.use(cors({ origin: "*" }));
app.use(bodyParser.json({ limit: "1024mb" }));
app.use(
  bodyParser.urlencoded({
    limit: "2048mb",
    extended: true,
    parameterLimit: 102400,
  })
);

// Request URL
app.use(async function (req, res, next) {
  logger.info(`URL => ${req.url}`);
  await database.query(`SET GLOBAL sql_mode = 'NO_ENGINE_SUBSTITUTION'`);

  next();
});

var superAdminLogin = require("./modules/SuperAdmin/Authentication/auth.routes");
var organizationRoutes = require("./modules/Organization/organizations.routes");
var storeRoutes = require("./modules/Store/store.routes");
var dashboardRoutes = require("./modules/Dashboard/dashboard.routes");

app.use(superAdminLogin, organizationRoutes, storeRoutes, dashboardRoutes);
const options = {
  cert: fs.readFileSync(
    "../../../etc/letsencrypt/live/apirental.aamantranam.com/fullchain.pem"
  ),
  key: fs.readFileSync(
    "../../../etc/letsencrypt/live/apirental.aamantranam.com/privkey.pem"
  ),
};
const server = https.createServer(options, app).listen(PORT, function () {
  console.log("server listening", PORT);

  //   // REDIS
  //   // redis = require('./Utils/initRedis');
  //   // this.redis;
});
// app.listen(PORT,()=>{logger.info(`app running on port ${PORT}`)})

database.sync();
