const Sequelize = require("sequelize");
const database = require("../database");

const SuperadminOrganizationModel=database.define("organization",{
    org_id:{
        type:Sequelize.INTEGER,
        allowNull:false,
        autoIncrement:true,
        primaryKey:true,
    },
    firstname:{
        type:Sequelize.STRING
    },
    lastname:{
        type:Sequelize.STRING
    },
    company_name:{
        type:Sequelize.STRING
    },
    email:{
        type:Sequelize.STRING
    },
    phone:{
        type:Sequelize.STRING
    },
    address:{
        type:Sequelize.TEXT
    },
    gst:{
        type:Sequelize.STRING
    },
    db_name:{
        type:Sequelize.STRING
    },
    username:{
        type:Sequelize.STRING
    },
    password:{
        type:Sequelize.STRING
    },
    domain_baseurl:{
        type:Sequelize.STRING
    },
    status:{
        type:Sequelize.INTEGER,
        comment:"1-active : 0-deactive",
        defaultValue:1,
    },
    register_date:{
        type:Sequelize.STRING,
    },
    expiry_date:{
        type:Sequelize.STRING
    },   
},{
    timestamps:false,
    tableName:"organization"
})

module.exports=SuperadminOrganizationModel;
