const ResponseHelpers = require("../../Helper/ResponseHelper")
const {logger}= require("../../utils/logger")
const Models = require("../../models/index.models")

const countOrgdataandExpireStoreService = async (data)=>{
    try {
        const countOrganization = await Models.database.query(`SELECT COUNT(org_id) as count FROM organization`,{type:Models.QueryTypes.SELECT})
        const countTodayExpireStore = await Models.database.query(`SELECT COUNT(store_id) as count FROM stores WHERE STR_TO_DATE(expiry_date, '%d-%m-%Y') = STR_TO_DATE('${data.today_date}', '%d-%m-%Y')`,{type:Models.QueryTypes.SELECT})

        const Countdata = {
            orgCount :countOrganization[0].count,
            storeCount:countTodayExpireStore[0].count
        }

        if(countOrganization != null || countTodayExpireStore != null){
            return ResponseHelpers.serviceToController(1,Countdata,"Organization List count and Today's Expire Store List Count Get Successfully")
        }else{
            return ResponseHelpers.serviceToController(0,[],"Organization List count and Today's Expire Store List Count Not Found")
        }

    } catch (error) {
        logger.error("------------------------------------- countOrgdataandExpireStoreService --------------------------------------")
        logger.error(error)
        return ResponseHelpers.serviceToController(2,[],"ERROR FROM countOrgdataandExpireStoreService SERVICE CATCH")
    }
}

module.exports={countOrgdataandExpireStoreService}