const { Sequelize, Op } = require("sequelize");
const ResponseHelpers = require("../../Helper/ResponseHelper");
const Models = require("../../models/index.models");
// const orgModels =require("../../orgModels/orgindex.models")
const { logger } = require("../../utils/logger");
const moment = require("moment");
const md5 = require("md5");
const { ChangeDateFieldTypeChangeFunction } = require("../../utils/commonDateTypeChangeFun");
const {
    DATABASEUSERNAME,
    DATABASEPASSWORD,
    DATABASEHOST,
  } = require("../../config");

global.orgSequelize = "";

const insertOrganizationService = async(organizationdata)=>{
    try 
    {
        const findEmailExist = await Models.database.query(`SELECT * FROM organization WHERE status = 1 AND (email='${organizationdata.email}' 
                                                            OR db_name = '${organizationdata.db_name}' OR username = '${organizationdata.username}' 
                                                            OR domain_baseurl = '${organizationdata.domain_baseurl}')`,{type:Models.QueryTypes.SELECT})

        if (findEmailExist.length <= 0) {
            if(organizationdata.username.match(/root/gi) != null) {
                return ResponseHelpers.serviceToController(3,[],"Not Allowed as root Username")
            }else{
                const insertOrganization = await Models.SuperadminOrganizationModel.create({
                    firstname : organizationdata.firstname,
                    lastname:organizationdata.lastname,
                    company_name:organizationdata.company_name,
                    email:organizationdata.email,
                    phone:organizationdata.phone,
                    address:organizationdata.address,
                    gst:organizationdata.gst,
                    db_name:organizationdata.db_name,
                    username:organizationdata.username,
                    password:md5(organizationdata.password),
                    domain_baseurl:organizationdata.domain_baseurl,
                    register_date:moment().format("DD-MM-YYYY")
                })
    
                if (insertOrganization != null) {
                    // INSERT ONE STORE 
                    const insertOneStore =await Models.superadminStoresModel.create({
                        store_name:organizationdata.company_name,
                        store_no:1,
                        org_id:insertOrganization.dataValues.org_id,
                        purchase_date:insertOrganization.dataValues.register_date,
                        expiry_date: moment(insertOrganization.dataValues.register_date,"DD-MM-YYYY").add(1, 'year').format('DD-MM-YYYY')
                    })
                    if (insertOneStore != null) {  
                        // CREATE ORGANIZATION DATABASE  
                        const databaseName = organizationdata.db_name ;
                        const connection = new Sequelize("", DATABASEUSERNAME, DATABASEPASSWORD, {
                            host: DATABASEHOST,
                            dialect: "mysql",
                          });
                          await connection.query(`CREATE DATABASE IF NOT EXISTS ${databaseName}`);
    

                          // CONNECT NEW CREATE DATABASE
                          orgSequelize = await new Sequelize(databaseName, DATABASEUSERNAME, DATABASEPASSWORD, {
                            host: DATABASEHOST,
                            dialect: "mysql",
                            logging:false,
                          });   

                          exports.OrgSequelize  = orgSequelize;
                           
                          await orgSequelize.query(`CREATE USER IF NOT EXISTS '${organizationdata.username}'@'localhost' IDENTIFIED BY '${organizationdata.password}'`);
                          await orgSequelize.query(`GRANT ALL PRIVILEGES ON *.* TO '${organizationdata.username}'@'localhost' WITH GRANT OPTION`)

                          const orgIndexModel = require("../../orgModels/orgindex.models")  

                         
                        // REQUIRE ALL TABLE FILES FOR CREATE TABLE
                        let subcategoryTable = require('../../orgModels/subcategory.model');
                        let categoryTable = require('../../orgModels/category.model');
                        let colorTable = require('../../orgModels/colors.model');
                        let customerTable = require('../../orgModels/customer.model');
                        let leadTable = require('../../orgModels/lead.model');
                        let organizationTable = require('../../orgModels/organization.model');
                        let productTable = require('../../orgModels/product.model');
                        let productMediaTable = require('../../orgModels/productMedia.model');
                        let serviceUserTable = require('../../orgModels/serviceuser.model');
                        let serviceUserTypeTable = require('../../orgModels/serviceusertype.model');
                        let sizeTable = require('../../orgModels/sizes.model');
                        let storeTable = require('../../orgModels/stores.model');
                        let storeWiseUserTable = require('../../orgModels/storewiseadmin.model');
                        let leadfollowupTable =require('../../orgModels/leadfollowup.model')
                        let leadHistoryTable =require('../../orgModels/leadhistory.model')
                        let orderTable =require('../../orgModels/orders.model')
                        let orderDetailTable =require('../../orgModels/orderDetail.model')
                        let incomeExpenseTable = require('../../orgModels/incomeexpense.model')
                        let leadAttributesTable = require('../../orgModels/leadAttributes.model')
                        let paymentMethodTable = require('../../orgModels/leadAttributes.model')
                        let washingProductTable = require('../../orgModels/washingProduct.model')
                        let websettingTable = require('../../orgModels/websetting.model')
                        let orderPaymentHistoryTable = require('../../orgModels/orderPaymentHistory')
    
                        const tablearr =['../../orgModels/subcategory.model','../../orgModels/category.model','../../orgModels/colors.model',
                                    '../../orgModels/customer.model','../../orgModels/lead.model','../../orgModels/organization.model','../../orgModels/product.model',
                                    '../../orgModels/productMedia.model','../../orgModels/serviceuser.model','../../orgModels/serviceusertype.model','../../orgModels/sizes.model',
                                    '../../orgModels/stores.model','../../orgModels/storewiseadmin.model','../../orgModels/leadfollowup.model','../../orgModels/leadhistory.model',
                                    '../../orgModels/orders.model','../../orgModels/orderDetail.model','../../orgModels/incomeexpense.model','../../orgModels/leadAttributes.model',
                                    '../../orgModels/leadAttributes.model','../../orgModels/washingProduct.model','../../orgModels/websetting.model','../../orgModels/orderPaymentHistory']
    
                        for (let index = 0; index < tablearr.length; index++) {
                            delete require.cache[require.resolve(tablearr[index])];
                        }
    
                       subcategoryTable = require('../../orgModels/subcategory.model');
                       categoryTable = require('../../orgModels/category.model');
                       colorTable = require('../../orgModels/colors.model');
                       customerTable = require('../../orgModels/customer.model');
                       leadTable = require('../../orgModels/lead.model');
                       organizationTable = require('../../orgModels/organization.model');
                       productTable = require('../../orgModels/product.model');
                       productMediaTable = require('../../orgModels/productMedia.model');
                       serviceUserTable = require('../../orgModels/serviceuser.model');
                       serviceUserTypeTable = require('../../orgModels/serviceusertype.model');
                       sizeTable = require('../../orgModels/sizes.model');
                       storeTable = require('../../orgModels/stores.model');
                       storeWiseUserTable = require('../../orgModels/storewiseadmin.model');
                       leadfollowupTable =require('../../orgModels/leadfollowup.model')
                       leadHistoryTable =require('../../orgModels/leadhistory.model')
                       orderTable =require('../../orgModels/orders.model')
                       orderDetailTable =require('../../orgModels/orderDetail.model')
                       incomeExpenseTable = require('../../orgModels/incomeexpense.model')
                       leadAttributesTable = require('../../orgModels/leadAttributes.model')
                       paymentMethodTable = require('../../orgModels/leadAttributes.model')
                       washingProductTable = require('../../orgModels/washingProduct.model')
                       websettingTable = require('../../orgModels/websetting.model')
                       orderPaymentHistoryTable = require('../../orgModels/orderPaymentHistory')       
    
                        for (const path in require.cache) {
                            if (path.endsWith('.js')) { // only clear *.js, not *.node
                              delete require.cache[path]
                            }
                          }                 
                        await orgSequelize.sync(); 


                          ChangeDateFieldTypeChangeFunction(orgSequelize)

                          
                        // INSERT ORGANIZATION IN ORAGANIZATION TABLE OF ORGANIZATION DATABASE 
                          const insertOrgdataInOrganizationDatabase =await orgIndexModel.OrganizationModel.create({
                            firstname:organizationdata.firstname,
                            lastname:organizationdata.lastname,
                            email:organizationdata.email,
                            password:md5(organizationdata.password),
                            phone:organizationdata.phone,
                            address:organizationdata.address,
                            gst_no:organizationdata.gst,
                            total_store : 1,
                            o_user_type:0
                            })
                            
                            // INSERT RECORD IN LEAD ATTRIBUTES TABLE IN ORGANIZATION DATABASE
                            const leadAttributesArray = [
                                {lead_attribute_name : "New" ,type : 1},
                                {lead_attribute_name : "Processing" ,type : 1},
                                {lead_attribute_name : "Close-by" ,type : 1},
                                {lead_attribute_name : "Confirm" ,type : 1},
                                {lead_attribute_name : "Cancel" ,type : 1},
                                {lead_attribute_name : "Online" ,type : 2},
                                {lead_attribute_name : "Offline" ,type : 2},
                                {lead_attribute_name : "Website" ,type : 2},
                                {lead_attribute_name : "Whatsapp" ,type : 2},
                            ];
                            for (let index = 0; index < leadAttributesArray.length; index++) {
                                await orgIndexModel.LeadAttributesModel.create({
                                    lead_attribute_name:leadAttributesArray[index].lead_attribute_name,
                                    type:leadAttributesArray[index].type,
                                    createdBy:0
                                })
                            }
                            
                            // INSERT WASHERMAN RECORD
                            const insertWashermenRecord = await orgIndexModel.ServiceusertypeModel.create({
                                s_u_t_name:"Washermen",
                                created_by:0
                            })
    
                            // INSERT WEBSETTING ID IN WEBSETTING TABLE
                            const insertWebsettingId = await orgIndexModel.WebsettingModel.create({
                                websetting_id:1
                            })
                           
                            if (insertOrgdataInOrganizationDatabase != null && insertWashermenRecord != null ) {
                                return ResponseHelpers.serviceToController(1,insertOrganization,"Organization Add Successfully...")                            
                            }   
                    } else {
                        return ResponseHelpers.serviceToController(0,[],"Organization Not Add..!")
                    }
                }
            }            
        }else{
            for (let index = 0; index < findEmailExist.length; index++) {
                if(findEmailExist[index].email == organizationdata.email){
                    return ResponseHelpers.serviceToController(3,[],"Organization Already Exist..!")
                }else if(findEmailExist[index].db_name == organizationdata.db_name){
                    return ResponseHelpers.serviceToController(3,[],"Database Already Exist..!")
                }else if(findEmailExist[index].username == organizationdata.username){
                    return ResponseHelpers.serviceToController(3,[],"Username Already Exist..!")
                }else if(findEmailExist[index].domain_baseurl == organizationdata.domain_baseurl){
                    return ResponseHelpers.serviceToController(3,[],"Domain URL Already Exist..!")
                }               
            }  
        }      
    } catch (error) {
        logger.error("------------------------------ insertOrganizationService --------------------------------")
        logger.error(error)
        return ResponseHelpers.serviceToController(2,[],"ERROR FROM insertOrganizationService SERVICE")
    }    
}

//  GET ORGANIZATION DATA WITH SEARCH PAGINATION ACTIVE DEACTIVE AND ALL 
const getOrganizationService =async(organizationdata)=>{
try {
    const startPage = (organizationdata.page - 1) * organizationdata.perPage;
    const perPage = organizationdata.perPage;
    let organizationSearchQuery = "";
    let organizationStatusQuery = "";

    // SEARCH QUERY
    if(organizationdata.searchValue != null || organizationdata.searchValue != ''){
        organizationSearchQuery =`(CONCAT(firstname , " " , lastname) LIKE '%${organizationdata.searchValue}%'
                                  OR company_name LIKE'%${organizationdata.searchValue}%' OR email LIKE '%${organizationdata.searchValue}%' OR phone LIKE '%${organizationdata.searchValue}%' OR address LIKE
                                 '%${organizationdata.searchValue}%' OR gst LIKE '%${organizationdata.searchValue}%' OR db_name LIKE '%${organizationdata.searchValue}%' OR username LIKE '%${organizationdata.searchValue}%'
                                  OR domain_baseurl LIKE '%${organizationdata.searchValue}%')`
    }

    // ACTIVE-DEACTIVE AND ALL 
    if(organizationdata.status != null){
        if (organizationdata.status == -1) {
            organizationStatusQuery += ``
        }else{
            organizationStatusQuery =`AND status = ${organizationdata.status}`
        }
    }
    const getorganization = await Models.database.query(`SELECT * FROM organization WHERE  ${organizationSearchQuery} ${organizationStatusQuery}  ORDER BY org_id DESC LIMIT ${startPage} ,${perPage}`,{type:Models.QueryTypes.SELECT})
    const countorganization = await Models.database.query(`SELECT COUNT(org_id) as count FROM organization WHERE ${organizationSearchQuery} ${organizationStatusQuery} `,{type:Models.QueryTypes.SELECT})

    const data = {
        data: getorganization,
        count: countorganization[0].count,
      };

    if(getorganization != null){
        return ResponseHelpers.serviceToController(1,data,"Organization Get Successfully...")
    }else{
        return ResponseHelpers.serviceToController(0,[],"Organization Not Get..!")
    }
} catch (error) {
    logger.error("--------------------------------- getOrganizationService --------------------------------")
    logger.error(error)
    return ResponseHelpers.serviceToController(2,[],"ERROR FROM getOrganizationService SERVICE CATCH")
}
}

const updateOrganizationService = async(organizationdata)=>{
    try {

        const findPassword = await Models.SuperadminOrganizationModel.findOne({
            raw: true,
            where: { org_id: organizationdata.org_id},
        })
            if(organizationdata.username.match(/root/gi) != null){
                return ResponseHelpers.serviceToController(3,[],"Not Allowed as root Username")
            }else{
                var updateOrganization = await Models.SuperadminOrganizationModel.update({
                    firstname:organizationdata.firstname,
                    lastname:organizationdata.lastname,
                    company_name:organizationdata.company_name,
                    email:organizationdata.email,
                    phone:organizationdata.phone,
                    address:organizationdata.address,
                    gst:organizationdata.gst,
                    db_name:organizationdata.db_name,
                    username:organizationdata.username,
                    password:organizationdata.password == undefined ? findPassword.password : md5(organizationdata.password),
                    domain_baseurl:organizationdata.domain_baseurl,
                },
                {
                    where:{org_id:organizationdata.org_id}
                })
            }
        
        const connection = new Sequelize("", DATABASEUSERNAME, DATABASEPASSWORD, {
            host: DATABASEHOST,
            dialect: "mysql",
            logging:false,
          });
        // UPDATE ORGANIZATION SQL USERNAME
        if(organizationdata.old_username != organizationdata.username ){
          await connection.query(`RENAME USER '${organizationdata.old_username}'@'localhost' TO '${organizationdata.username}'@'localhost';`)         
        }
        // UPDATE ORGANIZATION SQL PASSWORD
        if(organizationdata.password != undefined ){
          await connection.query(`ALTER USER ${organizationdata.username}@localhost IDENTIFIED BY '${(organizationdata.password)}';  `)
        }
       
        if(updateOrganization != 0){ 
            orgSequelize = await new Sequelize(organizationdata.db_name, DATABASEUSERNAME, DATABASEPASSWORD, {
                host: DATABASEHOST,
                dialect: "mysql",
                logging:false,
            });
            exports.OrgSequelize  = orgSequelize; 
            let orgIndexModel = require('../../orgModels/orgindex.models'); 
            
            // UPDATE ORGANIZATION DETAIL IN ORAGNIZATION DATABASE TABLE
                await orgIndexModel.OrganizationModel.update({
                firstname:organizationdata.firstname,
                lastname:organizationdata.lastname,
                email:organizationdata.email,
                phone:organizationdata.phone,
                address:organizationdata.address,
                gst_no:organizationdata.gst,
                password:organizationdata.password == undefined ? findPassword.password : md5(organizationdata.password),
            },{where:{email:organizationdata.old_email}})

            return ResponseHelpers.serviceToController(1,updateOrganization,"Organization Update Successfully...")
        }else{
            return ResponseHelpers.serviceToController(3,[],"You Have Not Made Any Changes")
        }
    } catch (error) {
        logger.error("-------------------------------------- updateOrganizationService ------------------------------------------")
        logger.error(error)
        return ResponseHelpers.serviceToController(2,[],"ERROR FROM updateOrganizationService SERVICE CATCH")
    }
}

const deleteOrganizationService =async(organizationdata)=>{
    try {
        const deleteorganization =await Models.SuperadminOrganizationModel.destroy(
            {
                where:{org_id:organizationdata.org_id }
            }) 
            if(deleteorganization != 0){
                // DLETE STORE
                await Models.superadminStoresModel.destroy({
                    where:{org_id:organizationdata.org_id}
                })

                // DELETE ORGANIZATION DATABASE and SQL USER
                const connection = new Sequelize("", DATABASEUSERNAME, DATABASEPASSWORD, {
                    host: DATABASEHOST,
                    dialect: "mysql",
                    logging:false,
                  });
                await connection.query(`DROP DATABASE IF EXISTS ${organizationdata.db_name}`)
                await connection.query(`DROP USER IF EXISTS '${organizationdata.username}'@'localhost'`)
                return ResponseHelpers.serviceToController(1,deleteorganization,"Organization Deleted Successfully...") 
            }else{
                return ResponseHelpers.serviceToController(0,[],"Organization Not Deleted..!")
            }
    } catch (error) {
        logger.error("--------------------------------- deleteOrganizationService ----------------------------------------")
        logger.error(error)
        return ResponseHelpers.serviceToController(2,[],"ERROR FROM deleteOrganizationService SERIVCE CATCH")
    }
}

const updateOrganizationStatusService = async(statusdata)=>{
    try {       
     
        const updatestatus =await Models.database.query(`UPDATE organization SET status = ${statusdata.status} WHERE org_id =${statusdata.org_id}`,{type:Models.QueryTypes.UPDATE})
        const statusname = statusdata.status == 1 ? "Active" : "Deactive";

        // CONNECT ORGANIZATION DATABASE
        orgSequelize = await new Sequelize(statusdata.db_name, DATABASEUSERNAME, DATABASEPASSWORD, {
            host: DATABASEHOST,
            dialect: "mysql",
            logging:false,
        });
        exports.OrgSequelize  = orgSequelize;     
        // UPDATE USERS STATUS IN ORGANIZATION DATABASE TABLE
        const updateOrganizationStatus = await orgSequelize.query(`UPDATE organization SET status = ${statusdata.status}`)

        if(updatestatus != 0 && updateOrganizationStatus != 0 ){           
            return ResponseHelpers.serviceToController(1,updatestatus,`Organization ${statusname} Successfully...`)
            
        }else{
            return ResponseHelpers.serviceToController(0,[],`Organization Not ${statusname}..!`)
        }        
    } catch (error) {
        logger.error("------------------------------------ updateOrganizationStatusService --------------------------------------")
        logger.error(error)
        return ResponseHelpers.serviceToController(2,[],"ERROR FROM updateOrganizationStatusService SERVICE CATCH")
    }
} 

module.exports = {insertOrganizationService , getOrganizationService,updateOrganizationService,deleteOrganizationService,updateOrganizationStatusService}