const ResponseHelpers=require("../../../Helper/ResponseHelper");
const { REQUIRED_VALIDATION_MESSAGE } = require("../../../constant");
const { logger } = require("../../../utils/logger");
const { validations } = require("../../../utils/validations");
const superAdminLoginService = require("./auth.services");

var superAdminLoginController=async(req,res)=>{
    try {
        const SuperAdminLoginData=req.body;
        const passwordValidation=validations("Required",SuperAdminLoginData.password,REQUIRED_VALIDATION_MESSAGE);
        const loginValidation=validations("Required",SuperAdminLoginData.loginkey,REQUIRED_VALIDATION_MESSAGE);

        if(passwordValidation.status !== 0){
            ResponseHelpers.BadRequest(res,passwordValidation.description);
        }else if(loginValidation.status !== 0){
            ResponseHelpers.BadRequest(res,loginValidation.description);
        }else{
            const data=await superAdminLoginService(SuperAdminLoginData);
            if(data.status == 1){
                ResponseHelpers.Success(res,data.data,data.description)
            }else{
                ResponseHelpers.BadRequest(res,data.description)
            }
        }
    } catch (error) {
        ResponseHelpers.Error(res,"Something went wrong, Please Try Again");
        logger.error(`-----------ERROR FROM superAdminLoginController CONTROLLER------------`);
        logger.error(error);
    }
}

module.exports=superAdminLoginController;