const moment = require("moment");
const CryptoJS = require('crypto-js')
const Models=require("../../../models/index.models");
const { logger } = require("../../../utils/logger");
const ResponseHelpers=require("../../../Helper/ResponseHelper");
const { Op } = require("sequelize");
const md5 = require("md5");
const { DDMMYYYYHHmmss } = require("../../../constant");
const { CRYPTOJSKEY } = require("../../../config/index");

const superAdminLoginService=async (superAdminData)=>{
    try {
        var auth_token=CryptoJS.AES.encrypt(
            superAdminData.loginkey + "_" + moment().format(DDMMYYYYHHmmss),CRYPTOJSKEY
        ).toString();
        const SuperAdminLogin=await Models.SuperAdminModel.findOne({
            raw:true,
            where:{
                [Op.or]:[
                    {phone:superAdminData.loginkey},
                    {email:superAdminData.loginkey}
                ],
                password:md5(superAdminData.password),
            }
        });
        Models.SuperAdminModel.update({
            auth_token:auth_token
        },{where:{email:superAdminData.loginkey}})
        if(SuperAdminLogin != null){
            SuperAdminLogin["auth_token"]=auth_token;
            return ResponseHelpers.serviceToController(1,SuperAdminLogin,"Login Successfully....");
        }else{
            return ResponseHelpers.serviceToController(0,[],"Invalid Username or Password");
        }
    } catch (error) {
        logger.error(`---------------ERROR FROM superAdminLoginService SERVICE---------------`);
        logger.error(error);
        return ResponseHelpers.serviceToController(0,[],"ERROR FROM superAdminLoginService SERVICE CATCH");
    }
}

module.exports=superAdminLoginService;