const Sequelize = require("sequelize");
const sequelize = require("../database");

const leadModel = orgSequelize.define(
  "leads",
  {
    lead_id: {
      type: Sequelize.INTEGER,
      allowNull: false,
      autoIncrement: true,
      primaryKey: true,
    },
    customer_id: { type: Sequelize.INTEGER },
    store_id: { type: Sequelize.INTEGER },
    created_by: { type: Sequelize.INTEGER },
    converted_by: { type: Sequelize.INTEGER },
    assign_to: { type: Sequelize.INTEGER },
    comment: { type: Sequelize.TEXT },
    date_time: { type: Sequelize.STRING },
    cancel_reason: {
      type: Sequelize.TEXT,
      allowNull: true,
    },
    status_id: {
      type: Sequelize.INTEGER,
      comment: "1-new-lead 2-followup 3-confirm 4-cancel",
      defaultValue: 1,
    },
    source_id: {
      type: Sequelize.INTEGER,
    },
    reference: {
      type: Sequelize.STRING,
    },
    next_followup_date: {
      type: Sequelize.STRING,
    },
    followup_counter: {
      type: Sequelize.INTEGER,
      defaultValue:0
    },
    created_at: {
      type: Sequelize.STRING,
    },
    updated_at: {
      type: Sequelize.STRING,
    },
  },
  {
    timestamps: false,
    tableName: "leads",
  }
);

module.exports = leadModel;
