const Sequelize = require("sequelize")
const sequelize = require("../database")

const OrderDetailsModel = orgSequelize.define(
    "orderDetails", {
      order_detail_id: {
        primaryKey: true,
        type: Sequelize.INTEGER,
        autoIncrement: true,
        allowNull: false
      },
      order_id: { type: Sequelize.INTEGER },
      product_id: { type: Sequelize.INTEGER },
      user_quantity: { type: Sequelize.INTEGER },
      washing_quantity: { type: Sequelize.INTEGER, defaultValue: 0 },
      base_rent_amount: { type: Sequelize.STRING },
      rent_amount: { type: Sequelize.STRING },
      discount_amount: { type: Sequelize.STRING },
      remaining_amount: { type: Sequelize.STRING },
      description: { type: Sequelize.TEXT },
      returnDate: { type: Sequelize.STRING },
      defect_fine: { type: Sequelize.STRING, defaultValue: 0 },
      defect_fine_description: { type: Sequelize.TEXT },
      status: {
        type: Sequelize.INTEGER,
        comment: "0-not return 1-returned",
        defaultValue: 0
      },
      created_at: { type: Sequelize.STRING },
      updated_at: { type: Sequelize.STRING },
    }, {
        tableName: "orderDetails",
        timestamps: false
      }
    )

module.exports = OrderDetailsModel