const Sequelize = require("sequelize")
const sequelize = require("../database")

const OrderModel = orgSequelize.define(
    "orders",
    {
        order_id: {
            type: Sequelize.INTEGER,
            primaryKey: true,
            autoIncrement: true,
            allowNull: false
        },
        user_id: { type: Sequelize.INTEGER },
        customer_id: { type: Sequelize.INTEGER },
        store_id: {
            type: Sequelize.INTEGER,
            defaultValue: 0
        },
        total_rent: { type: Sequelize.STRING },
        total_deposits: { type: Sequelize.STRING, defaultValue: 0 },
        total_discount: { type: Sequelize.STRING },
        total_remaining_amt: { type: Sequelize.STRING },
        book_date: { type: Sequelize.STRING },
        book_time: {
            type: Sequelize.INTEGER,
            comment: "0-morning 1-afternoon 2-evening"
        },
        return_date: { type: Sequelize.STRING },
        return_time: {
            type: Sequelize.INTEGER,
            comment: "0-morning 1-afternoon 2-evening"
        },
        payment_method_id: { type: Sequelize.INTEGER, defaultValue: 0 },
        terms_condition: { type: Sequelize.TEXT },
        customer_name: { type: Sequelize.STRING },
        customer_email: { type: Sequelize.STRING },
        customer_phone: { type: Sequelize.STRING },
        customer_address: { type: Sequelize.TEXT },
        company_name: { type: Sequelize.STRING },
        company_email: { type: Sequelize.STRING },
        company_phone: { type: Sequelize.STRING },
        company_address: { type: Sequelize.TEXT },
        company_logo: { type: Sequelize.STRING },
        bank_name: { type: Sequelize.STRING },
        account_no: { type: Sequelize.STRING },
        ifsc_code: { type: Sequelize.STRING },
        signature: { type: Sequelize.STRING },
        invoice_prefix: { type: Sequelize.STRING },
        invoice_start: { type: Sequelize.INTEGER },
        invoice_start_type: { type: Sequelize.INTEGER, comment: "1-org or p_org , 2-seperate" },
        defect_fine:{type:Sequelize.STRING, defaultValue: 0},
        defect_fine_description:{type:Sequelize.TEXT},
        order_type: { type: Sequelize.INTEGER, comment: "0-pending , 1-completed", defaultValue: 0 },
        created_at: { type: Sequelize.STRING },
        updated_at: { type: Sequelize.STRING },
    }, {
    tabelName: "orders",
    timestamps: false
}
)
module.exports = OrderModel;