const Sequelize = require("sequelize");
const sequelize = require("../database");

const OrganizationModel = orgSequelize.define(
  "organization",
  {
    organization_id: {
      type: Sequelize.INTEGER,
      allowNull: false,
      primaryKey: true,
      autoIncrement: true,
    },
    firstname: { type: Sequelize.STRING, },
    lastname: { type: Sequelize.STRING, },
    email: { type: Sequelize.STRING },
    password: { type: Sequelize.STRING },
    phone: { type: Sequelize.STRING },
    address: { type: Sequelize.TEXT },
    gst_no: { type: Sequelize.STRING },
    status: { type: Sequelize.INTEGER, comment: "-1 : Expired , 0 : Deactive , 1 : Active", defaultValue: 1},
    deleted: { type: Sequelize.INTEGER, comment: "0 : Deactive , 1 : Active",  defaultValue: 1},
    o_user_type: { type: Sequelize.INTEGER, comment: "0-organization,1-staff" },
    parent_user_id: { type: Sequelize.INTEGER, defaultValue: 0 },
    total_store: { type: Sequelize.INTEGER, },
    profile_image:{type:Sequelize.STRING},
    expiry_date: { type: Sequelize.STRING },
    auth_token: { type: Sequelize.STRING },
    otp: { type: Sequelize.INTEGER },
    created_at: { type: Sequelize.STRING },
    updated_at: { type: Sequelize.STRING },
  },
  {
    timestamps: false,
    tableName: "organization",
  }
);
module.exports = OrganizationModel;
