const Sequelize = require("sequelize")
const sequelize = require("../database")

const storesModel = orgSequelize.define(
    "stores",
  {
    store_id: {
      type: Sequelize.INTEGER,
      allowNull: false,
      autoIncrement: true,
      primaryKey: true,
    },
    store_name: { type: Sequelize.STRING },
    address: { type: Sequelize.TEXT },
    type: {
      type: Sequelize.INTEGER,
      comment: "0-A Part of Organization : 1-Separate",
    },
    gst: { type: Sequelize.STRING },
    phone: { type: Sequelize.STRING },
    email: { type: Sequelize.STRING },

    status: { type: Sequelize.INTEGER, comment: "0-deactive : 1-active" },
    expiry_date:{type:Sequelize.STRING},
    p_check_availability:{
      type: Sequelize.INTEGER,
      comment: "1 : Access , 0 : Denied",
      defaultValue: 0,
    }, 
    invoice_prefix: {
      type: Sequelize.STRING,
    },
    invoice_start: {
      type: Sequelize.INTEGER,
    },
    bank_name: {
      type: Sequelize.STRING,
    },
    account_no: {
      type: Sequelize.STRING,
    },
    gst_per: {
      type: Sequelize.STRING,
    },
    ifsc_code: {
      type: Sequelize.STRING,
    },
    terms_condition: {
      type: Sequelize.TEXT,
    },
    whatsapp_api: {
      type: Sequelize.STRING,
    },
    smtp_user: {
      type: Sequelize.STRING,
      allowNull: true,
    },
    smtp_email: {
      type: Sequelize.STRING,
    },
    smtp_password: {
      type: Sequelize.STRING,
    },
    smtp_port: {
      type: Sequelize.STRING,
      allowNull: true,
    },
    smtp_host: {
      type: Sequelize.STRING,
    },
    smtp_crypto: {
      type: Sequelize.STRING,
    },
    cc: {
      type: Sequelize.STRING,
    },
    created_at: { type: Sequelize.STRING },
    updated_at: { type: Sequelize.STRING },
  },
  {
    timestamps: false,
    tableName: "stores",
  }
)

module.exports = storesModel