const { EMAIL_VALIDATION_REGEX, MOBILE_VALIDATION_REGEX, PASSWORD_VALIDATION_REGEX, DATABASE_NAME_VALIDATION_REGEX, GST_VALIDATION_REGEX, SPACE_NOT_VALIADTION_REGEX } = require("../constant");
const ResponseHelpers = require("../Helper/ResponseHelper");
const { logger } = require("./logger");

let validations = (type,value,message="") => {
    try {
        let validationObj = { error: 0, message: "" }

        // requireField validation
        if (type == "required") {
            if (value == "" || value == null || value.trim().length == 0) {
                validationObj['error'] = 1;
                validationObj["message"] = message
            }
        }
        // email format validation
        // String convert email into string format if not
        // .trim() remove whitespace from email
        // .toLowerCase() convert email into lowercase
        // email validation
        if (type === "email") {
            if (!EMAIL_VALIDATION_REGEX.test(String(value).toLowerCase())) {
                validationObj['error'] = 1;
                validationObj["message"] = message
            }
        }   

        // mobile number validation 
        if (type === "mobile") {
            if (!MOBILE_VALIDATION_REGEX.test(value)) {
                validationObj['error'] = 1;
                validationObj["message"] = message

            }
        }

        // password validation
        if (type == "password") {
            if (!PASSWORD_VALIDATION_REGEX.test(value)) {
                validationObj['error'] = 1;
                validationObj["message"] = message

            }
        }

        // DATABASE NAME VALIDATION
        if (type == "database") {
            if (!DATABASE_NAME_VALIDATION_REGEX.test(value)) {
                validationObj['error'] = 1;
                validationObj["message"] = message

            }
        }

         // GST NUMBER VALIDATION
         if (type == "gst") {
            if (!GST_VALIDATION_REGEX.test(value)) {
                validationObj['error'] = 1;
                validationObj["message"] = message

            }
        }

        // DOMAIN URL VALIDATION
        if (type == "domain") {
            if (!SPACE_NOT_VALIADTION_REGEX.test(value)) {
                validationObj['error'] = 1;
                validationObj["message"] = message

            }
        }

        return ResponseHelpers.serviceToController(validationObj.error, [], validationObj.message)
    } catch (error) {
        logger.error(`==========ERROR FROM Common ValidationFunction ============`);
        logger.error(error);
        return ResponseHelpers.serviceToController(0, [], "ERROR FROM Common ValidationFunction")
    }
}

const removeSpace = (data) => {
    return Object.entries(data).reduce((obj, [key, values]) => {
        const strValue = values.toString();
        obj[key] = strValue.trim();
        return obj;
    }, {});
};

module.exports = { validations, removeSpace }